## limesuite 17.06.0+dfsg

=== CMakeLists.txt ===
########################################################################
## Create lime-suite project
########################################################################
cmake_minimum_required(VERSION 3.1.3)
set(CMAKE_CONFIGURATION_TYPES "Debug;Release;RelWithDebInfo" CACHE TYPE INTERNAL FORCE)
project("LimeSuite")

option(BUILD_SHARED_LIBS "Build the shared library" ON)

#include modules for finding CyAPI
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")

cmake_policy(SET CMP0015 OLD)
if(${CMAKE_MAJOR_VERSION} GREATER 2)
    cmake_policy(SET CMP0043 NEW)
endif()

if (CMAKE_BUILD_TYPE STREQUAL "")
   set(CMAKE_BUILD_TYPE "Release")
endif()

########################################################################
# Gather version information from the changelog
# LIME_SUITE_API_VERSION in VersionInfo.h reflects the major/minor
########################################################################
file(READ "${PROJECT_SOURCE_DIR}/Changelog.txt" changelog_txt)
string(REGEX MATCH "Release ([0-9]+)\\.([0-9]+)\\.([0-9]+) \\(" CHANGELOG_MATCH "${changelog_txt}")
if(NOT CHANGELOG_MATCH)
    message(FATAL_ERROR "Failed to extract version number from Changelog.txt")
endif(NOT CHANGELOG_MATCH)
set(VERSION_MAJOR "${CMAKE_MATCH_1}")
set(VERSION_MINOR "${CMAKE_MATCH_2}")
set(VERSION_PATCH "${CMAKE_MATCH_3}")

# the ABI compatibility number should be incremented when the ABI changes
# the format is to use the same major and minor, but to have an incrementing
# number if there are changes within the major.minor release series
set(LIME_SUITE_SOVER "${VERSION_MAJOR}.${VERSION_MINOR}-1")

# packagers may specify -DLIME_SUITE_EXTVER="foo" to replace the git hash
if (NOT LIME_SUITE_EXTVER)
    include(${PROJECT_SOURCE_DIR}/cmake/GetGitRevisionDescription.cmake)
    get_git_head_revision(GITREFSPEC GITHASH)
    if (GITHASH)
        string(SUBSTRING "${GITHASH}" 0 8 GITHASH)
        set(LIME_SUITE_EXTVER "g${GITHASH}")
    else (GITHASH)
        set(LIME_SUITE_EXTVER "unknown")
    endif (GITHASH)
endif()

set(LIME_SUITE_LIBVER "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
set(LIME_SUITE_VERSION "${LIME_SUITE_LIBVER}-${LIME_SUITE_EXTVER}")
string(TIMESTAMP BUILD_TIMESTAMP "%Y-%m-%d")

#LIME_SUITE_ROOT is compiled into the library to locate the install base.
#By default, the LIME_SUITE_ROOT is set to the CMAKE_INSTALL_PREFIX.
#However users may overload this by specifying -DLIME_SUITE_ROOT=<path>.
set(LIME_SUITE_ROOT "${CMAKE_INSTALL_PREFIX}" CACHE PATH
    "Installation root for lime::getLimeSuiteRoot()")
file(TO_CMAKE_PATH "${LIME_SUITE_ROOT}" LIME_SUITE_ROOT)

########################################################################
## compiler flags
########################################################################

#C++11 is a required language feature for this project
set(CMAKE_CXX_STANDARD 11)

if(CMAKE_COMPILER_IS_GNUCXX)

    #enable C++11 on older versions of cmake
    if (CMAKE_VERSION VERSION_LESS "3.1")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
    endif()

    #common warnings enabled
    add_compile_options(-Wall)

    #symbols are only exported from libraries/modules explicitly
    add_compile_options(-fvisibility=hidden)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility-inlines-hidden")
endif()

if (MSVC)
    include_directories(${PROJECT_SOURCE_DIR}/external/msvc)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    set( MSVC_MULTITHREAD_COMPILE_FLAGS "/MP")
    set( CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} ${MSVC_MULTITHREAD_COMPILE_FLAGS}" )
endif(MSVC)

if (APPLE)
   add_definitions(-D__unix__=1) #we use this for unix detection, but clang does not define it
endif(APPLE)

########################################################################
# rpath setup - http://www.cmake.org/Wiki/CMake_RPATH_handling
########################################################################
# use, i.e. don't skip the full RPATH for the build tree
option(CMAKE_SKIP_BUILD_RPATH "skip rpath build" FALSE)

# when building, don't use the install RPATH already
# (but later on when installing)
option(CMAKE_BUILD_WITH_INSTALL_RPATH "build with install rpath" FALSE)

# the RPATH to be used when installing, but only if it's not a system directory
option(CMAKE_AUTOSET_INSTALL_RPATH TRUE)
if(CMAKE_AUTOSET_INSTALL_RPATH)
LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}" isSystemDir)
IF("${isSystemDir}" STREQUAL "-1")
    SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}")
ENDIF("${isSystemDir}" STREQUAL "-1")
endif(CMAKE_AUTOSET_INSTALL_RPATH)

# add the automatically determined parts of the RPATH
# which point to directories outside the build tree to the install RPATH
option(CMAKE_INSTALL_RPATH_USE_LINK_PATH "build with automatic rpath" TRUE)

if(APPLE)
    set(CMAKE_MACOSX_RPATH ON)
endif()

########################################################################
## sqlite dependency
########################################################################
if(WIN32)
    add_subdirectory(external/sqlite-3.12)
    set(SQLITE3_FOUND TRUE)
    set(SQLITE3_INCLUDE_DIRS)
    set(SQLITE3_LIBRARIES sqlite3_static)
else()
    find_package(SQLite3)
    if (NOT SQLITE3_FOUND)
        message(SEND_ERROR "Failed to find sqlite3 devel, please install libsqlite3-dev")
    endif()

    message(STATUS "SQLITE3: ${SQLITE3_FOUND}")
    message(STATUS "SQLITE3_INCLUDE_DIRS: ${SQLITE3_INCLUDE_DIRS}")
    message(STATUS "SQLITE3_LIBRARIES: ${SQLITE3_LIBRARIES}")
endif()

########################################################################
## lime suite build
########################################################################
add_subdirectory(src)
add_subdirectory(mcu_program)
add_subdirectory(LimeUtil)

########################################################################
## SoapySDR bindings for LMS7 RFIC driver
########################################################################
add_subdirectory(SoapyLMS7)

########################################################################
## udev rules for linux usb
########################################################################
if (DEFINED UDEV_RULES_PATH)
    install(
        FILES ${CMAKE_CURRENT_SOURCE_DIR}/udev-rules/64-limesuite.rules
        DESTINATION ${UDEV_RULES_PATH})
endif()

########################################################################
## freedesktop environment integration
########################################################################
add_subdirectory(Desktop)

#########################################################################
# summary
#########################################################################
include(FeatureSummary)
message(STATUS "")
message(STATUS "######################################################")
message(STATUS "## ${PROJECT_NAME} enabled features")
message(STATUS "######################################################")
feature_summary(WHAT ENABLED_FEATURES)
message(STATUS "######################################################")
message(STATUS "## ${PROJECT_NAME} disabled features")
message(STATUS "######################################################")
feature_summary(WHAT DISABLED_FEATURES)
message(STATUS "Install prefix: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "Build timestamp: ${BUILD_TIMESTAMP}")
message(STATUS "Lime Suite version: ${LIME_SUITE_VERSION}")
message(STATUS "ABI/so version: ${LIME_SUITE_SOVER}")
include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/DownloadImages.cmake)

########################################################################
# uninstall target
########################################################################
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

#only add uninstall target if this is the top project
if(${CMAKE_PROJECT_NAME} STREQUAL ${PROJECT_NAME})
add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
endif()

find_package(Doxygen QUIET)

if(DOXYGEN_FOUND)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
  add_custom_target(doc
    ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile 
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Generating API documentation with Doxygen" VERBATIM
    )
endif()

=== Desktop/CMakeLists.txt ===
########################################################################
## Feature registration
########################################################################
if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
    set(LINUX TRUE)
endif()

include(FeatureSummary)
include(CMakeDependentOption)
cmake_dependent_option(ENABLE_DESKTOP "Enable LimeSuite launcher and icons" ON "LINUX" OFF)
add_feature_info(LimeSuiteDesktop ENABLE_DESKTOP "LimeSuite freedesktop integration")
if (NOT ENABLE_DESKTOP)
    return()
endif()

########################################################################
# menu launcher and MIME type
########################################################################
file(GLOB lime_suite_png_icons ${CMAKE_CURRENT_SOURCE_DIR}/lime-suite-*.png)

install(
    FILES
        lime-suite.desktop
        ${lime_suite_png_icons}
    DESTINATION share/Lime/Desktop
)

########################################################################
# install/uninstall scripts
########################################################################
install(
    PROGRAMS
        install
        uninstall
    DESTINATION share/Lime/Desktop
)

=== src/CMakeLists.txt ===
########################################################################
## public headers
########################################################################
set(LIME_SUITE_PUBLIC_HEADERS
    lime/LimeSuite.h
    VersionInfo.h
    Logger.h
    ErrorReporting.h
    SystemResources.h
    LimeSuiteConfig.h
    ADF4002/ADF4002.h
    lms7002m_mcu/MCU_BD.h
    lms7002m_mcu/MCU_File.h
    ConnectionRegistry/IConnection.h
    ConnectionRegistry/ConnectionHandle.h
    ConnectionRegistry/ConnectionRegistry.h
    lms7002m/LMS7002M.h
    lms7002m/LMS7002M_RegistersMap.h
    lms7002m/LMS7002M_parameters.h
    protocols/ADCUnits.h
    protocols/LMS64CCommands.h
    protocols/LMS64CProtocol.h
    protocols/ILimeSDRStreaming.cpp
    protocols/LMSBoards.h
    protocols/dataTypes.h
    protocols/fifo.h
    Si5351C/Si5351C.h
    FPGA_common/FPGA_common.h
    lime/LimeSuite.h
)

include(FeatureSummary)
include(CMakeDependentOption)
cmake_dependent_option(ENABLE_HEADERS "Enable install headers" ON "TRUE" OFF)
add_feature_info(LimeSuiteHeaders ENABLE_HEADERS "The lime suite headers")
if (ENABLE_HEADERS)
    install(
        FILES ${LIME_SUITE_PUBLIC_HEADERS}
        DESTINATION include/lime
    )
endif()

########################################################################
## lime suite library
########################################################################
set(LIME_SUITE_SOURCES
    Logger.cpp
    ErrorReporting.cpp
    ADF4002/ADF4002.cpp
    lms7002m_mcu/MCU_BD.cpp
    ConnectionRegistry/IConnection.cpp
    ConnectionRegistry/ConnectionHandle.cpp
    ConnectionRegistry/ConnectionRegistry.cpp
    lms7002m/LMS7002M_RegistersMap.cpp
    lms7002m/LMS7002M_parameters.cpp
    lms7002m/LMS7002M.cpp
    lms7002m/LMS7002M_RxTxCalibrations.cpp
	lms7002m/LMS7002M_BaseCalibrations.cpp
    lms7002m/goert.cpp
    lms7002m/mcu_dc_iq_calibration.cpp
    lms7002m/CalibrationCache.cpp
    lms7002m/LMS7002M_filtersCalibration.cpp
    lms7002m/LMS7002M_gainCalibrations.cpp
    protocols/LMS64CProtocol.cpp
    protocols/ILimeSDRStreaming.cpp
    Si5351C/Si5351C.cpp
    kissFFT/kiss_fft.c
    API/lms7_api.cpp
    API/lms7_device.cpp
    API/qLimeSDR.cpp
    FPGA_common/FPGA_common.cpp
    windowFunction.cpp
)

set(LIME_SUITE_INCLUDES
    ${CMAKE_CURRENT_SOURCE_DIR}
    API
    GFIR
    protocols
    ConnectionRegistry
    lms7002m_mcu
    ADF4002
    Si5351C
    lms7002m
    LTEpackets
    FPGA_common
    lms7002m_mcu
    ${PROJECT_SOURCE_DIR}/external/cpp-feather-ini-parser
    HPM7
    kissFFT
)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/VersionInfo.in.cpp
    ${CMAKE_CURRENT_BINARY_DIR}/VersionInfo.cpp @ONLY)
list(APPEND LIME_SUITE_SOURCES ${CMAKE_CURRENT_BINARY_DIR}/VersionInfo.cpp)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/SystemResources.in.cpp
    ${CMAKE_CURRENT_BINARY_DIR}/SystemResources.cpp @ONLY)
list(APPEND LIME_SUITE_SOURCES ${CMAKE_CURRENT_BINARY_DIR}/SystemResources.cpp)

if(CMAKE_COMPILER_IS_GNUCXX)
    list(APPEND LIME_SUITE_LIBRARIES -pthread)
endif(CMAKE_COMPILER_IS_GNUCXX)

#sqlite depedency
list(APPEND LIME_SUITE_INCLUDES ${SQLITE3_INCLUDE_DIRS})
list(APPEND LIME_SUITE_LIBRARIES ${SQLITE3_LIBRARIES})

include(FeatureSummary)
include(CMakeDependentOption)
cmake_dependent_option(ENABLE_LIBRARY "Enable build library" ON "SQLITE3_FOUND" OFF)
add_feature_info(LimeSuiteLibrary ENABLE_LIBRARY "The lime suite library")
if (ENABLE_LIBRARY)
    add_library(LimeSuite ${LIME_SUITE_SOURCES})
    target_link_libraries(LimeSuite ${LIME_SUITE_LIBRARIES})
    set_property(TARGET LimeSuite PROPERTY POSITION_INDEPENDENT_CODE TRUE)
    set_target_properties(LimeSuite PROPERTIES SOVERSION ${LIME_SUITE_SOVER})
    set_target_properties(LimeSuite PROPERTIES VERSION ${LIME_SUITE_LIBVER})
    set_target_properties(LimeSuite PROPERTIES DEFINE_SYMBOL "LIME_DLL_EXPORTS")
    target_include_directories(LimeSuite PUBLIC ${LIME_SUITE_INCLUDES})
    if(BUILD_SHARED_LIBS)
        target_compile_definitions(LimeSuite PUBLIC "LIME_DLL")
    endif()

    install(TARGETS LimeSuite
        LIBRARY DESTINATION lib${LIB_SUFFIX} # .so file
        ARCHIVE DESTINATION lib${LIB_SUFFIX} # .lib file
        RUNTIME DESTINATION bin              # .dll file
    )

	if (MSVC)
		set_target_properties(LimeSuite PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
	endif(MSVC)

    add_subdirectory(GFIR)
    set(LIME_SUITE_LIBS LimeSuite)
endif()

########################################################################
## Supported connections
########################################################################
include(ConnectionEVB7COM/CMakeLists.txt)
include(ConnectionSTREAM/CMakeLists.txt)
include(ConnectionSTREAM_UNITE/CMakeLists.txt)
include(ConnectionNovenaRF7/CMakeLists.txt)
include(Connection_uLimeSDR/CMakeLists.txt)
include(ConnectionXillybus/CMakeLists.txt)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/ConnectionRegistry/BuiltinConnections.in.cpp
    ${CMAKE_CURRENT_BINARY_DIR}/BuiltinConnections.cpp
)

target_sources(LimeSuite PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/BuiltinConnections.cpp)

########################################################################
## wx widgets dependency
########################################################################
set(wxWidgets_USE_DEBUG OFF)
set(wxWidgets_USE_UNICODE ON)
set(wxWidgets_USE_UNIVERSAL OFF)
set(wxWidgets_USE_STATIC ON)
find_package(wxWidgets COMPONENTS richtext xml html xrc adv aui core base gl)
message(STATUS "wxWidgets_DEFINITIONS: ${wxWidgets_DEFINITIONS}")
message(STATUS "wxWidgets_INCLUDE_DIRS: ${wxWidgets_INCLUDE_DIRS}")
message(STATUS "wxWidgets_LIBRARIES: ${wxWidgets_LIBRARIES}")

########################################################################
## LimeSuite GUI app
########################################################################
set(LMS7SUITE_GUI_SOURCES
    ADF4002/ADF4002_wxgui.cpp
    lms7002_wxgui/lms7002_pnlXBUF_view.cpp
    lms7002_wxgui/lms7002_wxgui.cpp
    lms7002_wxgui/lms7002_pnlRFE_view.cpp
    lms7002_wxgui/lms7002_pnlCalibrations_view.cpp
    lms7002_wxgui/lms7002_pnlTRF_view.cpp
    lms7002_wxgui/lms7002_pnlCDS_view.cpp
    lms7002_wxgui/lms7002_pnlLimeLightPAD_view.cpp
    lms7002_wxgui/lms7002_pnlBIST_view.cpp
    lms7002_wxgui/dlgViewIRAM.cpp
    lms7002_wxgui/lms7002_gui_utilities.cpp
    lms7002_wxgui/lms7002_pnlSX_view.cpp
    lms7002_wxgui/lms7002_pnlTBB_view.cpp
    lms7002_wxgui/lms7002_dlgVCOfrequencies.cpp
    lms7002_wxgui/lms7002_pnlRBB_view.cpp
    lms7002_wxgui/lms7002_pnlLDO_view.cpp
    lms7002_wxgui/lms7002_pnlAFE_view.cpp
    lms7002_wxgui/lms7002_pnlGains_view.cpp
    lms7002_wxgui/CoefficientFileParser.cpp
    lms7002_wxgui/lms7002_pnlRxTSP_view.cpp
    lms7002_wxgui/lms7002_mainPanel.cpp
    lms7002_wxgui/pnlBoardControls.cpp
    lms7002_wxgui/dlgViewSFR.cpp
    lms7002_wxgui/lms7002_pnlCLKGEN_view.cpp
    lms7002_wxgui/lms7002_pnlMCU_BD_view.cpp
    lms7002_wxgui/lms7002_pnlBIAS_view.cpp
    lms7002_wxgui/lms7002_dlgGFIR_Coefficients.cpp
    lms7002_wxgui/lms7002_pnlTxTSP_view.cpp
    lms7002_wxgui/lms7002_pnlR3.cpp
    LMS_Programing/LMS_Programing_wxgui.cpp
    utilities_gui/dlgConnectionSettings.cpp
    utilities_gui/pnlMiniLog.cpp
    utilities_gui/SPI_wxgui.cpp
    utilities_gui/dlgFullMessageLog.cpp
    utilities_gui/dlgDeviceInfo.cpp
    utilities_gui/utilities_gui.cpp
    lms7suiteAppFrame.cpp
    boards_wxgui/lms7002m_novena_wxgui.cpp
    RFSpark/RFSpark_wxgui.cpp
    Si5351C/Si5351C_wxgui.cpp
    lms7suiteApp_gui.cpp
    lms7suiteApp.cpp
    FPGAcontrols_wxgui/FPGAcontrols_wxgui.cpp
    HPM7/HPM7_wxgui.cpp
    dlgAbout.cpp
    numericSlider/numericSlider.cpp
    myriad7/myriad7_wxgui.cpp
    fftviewer_wxgui/fftviewer_wxgui.cpp
    fftviewer_wxgui/fftviewer_frFFTviewer.cpp
    lms7suiteEvents/lms7suiteEvents.cpp
    boards_wxgui/pnlQSpark.cpp
    boards_wxgui/pnluLimeSDR.cpp
    boards_wxgui/pnlUltimateEVB.cpp
    boards_wxgui/pnlBuffers.cpp
    kissFFT/kiss_fft.c
    windowFunction.cpp
    boards_wxgui/pnlLimeSDR.cpp
)

include(FeatureSummary)
include(CMakeDependentOption)
cmake_dependent_option(ENABLE_GUI "Enable build GUI" ON "ENABLE_LIBRARY;wxWidgets_FOUND" OFF)
add_feature_info(LimeSuiteGUI ENABLE_GUI "GUI Application for LimeSuite")
if (ENABLE_GUI)

    include_directories(lms7002_wxgui)
    include_directories(LMS_Programing)
    include_directories(utilities_gui)
    include_directories(RFSpark)
    include_directories(FPGAcontrols_wxgui)
    include_directories(numericSlider)
    include_directories(myriad7)
    include_directories(fftviewer_wxgui)
    include_directories(lms7suiteEvents)
    include_directories(boards_wxgui)
    include(${wxWidgets_USE_FILE})
    add_subdirectory(oglGraph)

    set(BINARY_OUTPUT_DIR "${CMAKE_BINARY_DIR}/bin")

    add_executable(LimeSuiteGUI ${LMS7SUITE_GUI_SOURCES} resources/resource.rc)
    set_target_properties(LimeSuiteGUI PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY ${BINARY_OUTPUT_DIR})
    target_link_libraries(LimeSuiteGUI LimeSuite oglGraph ${wxWidgets_LIBRARIES})

    if (MSVC)
        set_property(TARGET LimeSuiteGUI APPEND PROPERTY LINK_FLAGS /SUBSYSTEM:WINDOWS)
    endif(MSVC)

    install(TARGETS LimeSuiteGUI DESTINATION bin)

endif()

########################################################################
# boardEmulator -- creates serial port and imitates board communications
########################################################################
if(UNIX)
    add_executable(boardEmulator boardEmulator.cpp)
    target_link_libraries(boardEmulator LimeSuite)
endif()

#########################################################################
# utilities
#########################################################################
cmake_dependent_option(ENABLE_UTILITIES "Enable utility programs" OFF "ENABLE_LIBRARY" OFF)
add_feature_info(LimeSuiteUtilities ENABLE_UTILITIES "Additional utility programs for testing")
if(ENABLE_UTILITIES)
    include_directories(utilityTools)
    set(utility_src_files utilityTools/pllTest.cpp)
    add_executable(utilityTools ${utility_src_files} utilityTools/main.cpp)
    target_link_libraries(utilityTools LimeSuite)
endif()

#########################################################################
# tests
#########################################################################
add_subdirectory(tests)

#########################################################################
# examples
#########################################################################
add_subdirectory(examples)

=== src/ADF4002/CMakeLists.txt ===
set(adf4002_src_files
	ADF4002.cpp
	ADF4002_wxgui.cpp
)

add_library(ADF4002 STATIC ${adf4002_src_files})
target_include_directories(ADF4002 PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(ADF4002 LMS7002M)

=== src/ConnectionNovenaRF7/CMakeLists.txt ===
########################################################################
## Support for NovenaRF7 connection
########################################################################

set(THIS_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/ConnectionNovenaRF7)

set(CONNECTION_NOVENARF7_SOURCES
    ${THIS_SOURCE_DIR}/ConnectionNovenaRF7Entry.cpp
    ${THIS_SOURCE_DIR}/ConnectionNovenaRF7.cpp
    ${THIS_SOURCE_DIR}/ConnectionNovenaRF7_streaming.cpp
    ${THIS_SOURCE_DIR}/StreamChannel.cpp
)

include(CheckIncludeFile)
set(CMAKE_REQUIRED_DEFINITIONS -DNULL=0)
CHECK_INCLUDE_FILE(linux/spi/spidev.h HAS_SPIDEV_H)
CHECK_INCLUDE_FILE(linux/i2c-dev.h HAS_I2CDEV_H)

#require a special version of i2c-dev.h that comes with the libi2c-dev package
if (HAS_I2CDEV_H)
    include(CheckCSourceCompiles)
    set(code "#include <linux/i2c-dev.h>\nint main(){struct i2c_msg messages[2]; return 0;}")
    CHECK_C_SOURCE_COMPILES("${code}" HAS_I2C_MSG)
else (HAS_I2CDEV_H)
    set(HAS_I2C_MSG FALSE)
endif (HAS_I2CDEV_H)

########################################################################
## Feature registration
########################################################################
include(FeatureSummary)
include(CMakeDependentOption)
cmake_dependent_option(ENABLE_NOVENARF7 "Enable NovenaRF7" ON "ENABLE_LIBRARY;HAS_SPIDEV_H;HAS_I2C_MSG" OFF)
add_feature_info(ConnectionNovenaRF7 ENABLE_NOVENARF7 "NovenaRF7 Connection support")
if (NOT ENABLE_NOVENARF7)
    return()
endif()

########################################################################
## Add to library
########################################################################
target_sources(LimeSuite PRIVATE ${CONNECTION_NOVENARF7_SOURCES})

=== src/Connection_uLimeSDR/CMakeLists.txt ===
########################################################################
## Support for USB uLimeSDR connection
########################################################################

set(THIS_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/Connection_uLimeSDR)

if(WIN32)
    set(USB_FOUND TRUE)
    set(USB_INCLUDE_DIRS  ${THIS_SOURCE_DIR}/FTD3XXLibrary)

    #library directory based on x64 vs x86
    if (CMAKE_SIZEOF_VOID_P EQUAL 8)
        set(FTD3XX_LIB_DIR ${USB_INCLUDE_DIRS}/x64)
    else()
        set(FTD3XX_LIB_DIR ${USB_INCLUDE_DIRS}/Win32)
    endif()

    #default is to use static libs
    option(FTD3XX_STATIC "Use static libs for FTD3XX" TRUE)

    #force dynamic on MSVC2015 because of linker error
    if (MSVC14)
        set(FTD3XX_STATIC FALSE)
    endif()

    #when using static libs specify FTD3XX_STATIC
    if (FTD3XX_STATIC)
        set(USB_LIBRARIES ${FTD3XX_LIB_DIR}/Static/FTD3XX.lib SetupAPI)
        add_definitions(-DFTD3XX_STATIC)

    #when using dynamic libs install the dll to bin/
    else()
        set(USB_LIBRARIES ${FTD3XX_LIB_DIR}/FTD3XX.lib SetupAPI)
        install(FILES ${FTD3XX_LIB_DIR}/FTD3XX.dll DESTINATION bin)
    endif()

elseif(UNIX)
    find_package(libusb-1.0)
    set(USB_FOUND ${LIBUSB_1_FOUND})
    set(USB_INCLUDE_DIRS ${LIBUSB_1_INCLUDE_DIRS})
    set(USB_LIBRARIES ${LIBUSB_1_LIBRARIES})
endif()

message(STATUS "USB_INCLUDE_DIRS: ${USB_INCLUDE_DIRS}")
message(STATUS "USB_LIBRARIES: ${USB_LIBRARIES}")

set(CONNECTION_uLimeSDR_SOURCES
    ${THIS_SOURCE_DIR}/Connection_uLimeSDREntry.cpp
    ${THIS_SOURCE_DIR}/Connection_uLimeSDR.cpp
    ${THIS_SOURCE_DIR}/Connection_uLimeSDRing.cpp
)

set(CONNECTION_uLimeSDR_LIBRARIES
    ${USB_LIBRARIES}
)

########################################################################
## Feature registration
########################################################################
include(FeatureSummary)
include(CMakeDependentOption)
cmake_dependent_option(ENABLE_uLimeSDR "Enable uLimeSDR" ON "ENABLE_LIBRARY;USB_FOUND" OFF)
add_feature_info(Connection_uLimeSDR ENABLE_uLimeSDR "uLimeSDR Connection support")
if (NOT ENABLE_uLimeSDR)
    return()
endif()

########################################################################
## Add to library
########################################################################
target_include_directories(LimeSuite PUBLIC ${USB_INCLUDE_DIRS})
target_sources(LimeSuite PRIVATE ${CONNECTION_uLimeSDR_SOURCES})
target_link_libraries(LimeSuite ${CONNECTION_uLimeSDR_LIBRARIES})

=== src/examples/CMakeLists.txt ===
include(FeatureSummary)
include(CMakeDependentOption)
cmake_dependent_option(ENABLE_EXAMPLES "Enable library example programs" ON "ENABLE_LIBRARY" OFF)
add_feature_info(LimeSuiteExamples ENABLE_EXAMPLES "LimeSuite library API examples")
if (NOT ENABLE_EXAMPLES)
    return()
endif()

if (UNIX)
find_package(Gnuplot)
if (GNUPLOT_FOUND)
add_definitions(-DUSE_GNU_PLOT)
message(STATUS "GNUPlot Found")
endif()
endif()

add_executable(basicRX basicRX.cpp)
set_target_properties(basicRX PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
target_link_libraries(basicRX LimeSuite)

add_executable(singleRX singleRX.cpp)
set_target_properties(singleRX PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
target_link_libraries(singleRX LimeSuite)

add_executable(dualRXTX dualRXTX.cpp)
set_target_properties(dualRXTX PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
target_link_libraries(dualRXTX LimeSuite)

=== src/lms7002_wxgui/CMakeLists.txt ===
set(lms7002_gui_src_files	
	lms7002_wxgui.cpp
	lms7002_mainPanel.cpp
	lms7002_pnlAFE_view.cpp
	lms7002_pnlBIAS_view.cpp
	lms7002_pnlBIST_view.cpp
	lms7002_pnlCDS_view.cpp
	lms7002_pnlCLKGEN_view.cpp
	lms7002_pnlLDO_view.cpp
	lms7002_pnlLimeLightPAD_view.cpp
	lms7002_pnlTxTSP_view.cpp
	lms7002_pnlRxTSP_view.cpp
	lms7002_pnlRBB_view.cpp
	lms7002_pnlRFE_view.cpp
	lms7002_pnlSX_view.cpp
	lms7002_pnlTBB_view.cpp
	lms7002_pnlTRF_view.cpp
	lms7002_pnlXBUF_view.cpp
	lms7002_pnlCalibrations_view.cpp
	lms7002_gui_utilities.cpp
	lms7002_pnlMCU_BD_view.cpp
	dlgViewIRAM.cpp
	dlgViewSFR.cpp
	lms7002_dlgGFIR_Coefficients.cpp
	CoefficientFileParser.cpp
	lms7002_pnlBuffers_view.cpp
	lms7002_dlgVCOfrequencies.cpp
	pnlBoardControls.cpp
)
add_library(lms7002_wxgui STATIC ${lms7002_gui_src_files})
target_include_directories(lms7002_wxgui PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(lms7002_wxgui numericSlider)
target_link_libraries(lms7002_wxgui LMS7002M_MCU LMS7002M lms7suiteEvents)

=== src/tests/CMakeLists.txt ===
include(FeatureSummary)
include(CMakeDependentOption)
cmake_dependent_option(ENABLE_TESTS "Enable library test programs" OFF "ENABLE_LIBRARY" OFF)
add_feature_info(LimeSuiteTests ENABLE_TESTS "Download gtest and build test application")

if (NOT ENABLE_TESTS)
    return()
endif()

find_package(Threads REQUIRED)
include(ExternalProject)
# Download and install GoogleTest
ExternalProject_Add(
    gtest
    URL https://github.com/google/googletest/archive/release-1.8.0.zip
    PREFIX ${CMAKE_CURRENT_BINARY_DIR}
    # Disable install step
    INSTALL_COMMAND ""
)

add_library(libgtest IMPORTED STATIC GLOBAL)
add_dependencies(libgtest gtest)

# Set gtest properties
ExternalProject_Get_Property(gtest source_dir binary_dir)
set_target_properties(libgtest PROPERTIES
    "IMPORTED_LOCATION" "${binary_dir}/googlemock/gtest/libgtest.a"
    "IMPORTED_LINK_INTERFACE_LIBRARIES" "${CMAKE_THREAD_LIBS_INIT}"
)
include_directories("${source_dir}/googletest/include")

add_executable(tests 
    main.cpp
    streaming.cpp
    comms.cpp
)

target_link_libraries(tests
    libgtest
    LimeSuite
)

add_dependencies(tests LimeSuite)

=== debian/changelog ===
limesuite (17.06.0+dfsg-1) unstable; urgency=medium

  * New upstream release 17.06.0 (Closes: #869380)
  * Change SoapySDR ABI version in package names and dependencies from 0.5-2
    to 0.6
  * Change liblimesuite ABI version from 17.02-1 to 17.06-1
  * Build-Depend on versioned libsoapysdr0.6-dev instead of libsoapysdr-dev
  * Bump Standards-Version to 4.0.1, no changes required
  * Add fix-missing-udev-subsystem patch to add missing SUBSYSTEM match to
    udev rules
  * Add udev-use-tag-uaccess patch to use uaccess tag instead of plugdev group
    in udev rules
  * Include pkg-info.mk instead of using dpkg-parsechangelog in debian/rules

 -- Andreas Bombe <aeb@debian.org>  Fri, 11 Aug 2017 01:24:22 -0400

limesuite (17.02.1+dfsg-1) experimental; urgency=medium

  * New upstream release 17.02.1
    - Works correctly with current LimeSDR firmware (Closes: #858591)
  * Remove backported fix-abs-overload patch, included in release
  * Rename liblimesuite16.12-1 to liblimesuite17.02-1 due to soname
    change
  * Use SOURCE_DATE_EPOCH variable instead of hand crafted equivalent
    to set BUILD_TIMESTAMP in override-build-timestamp patch

 -- Andreas Bombe <aeb@debian.org>  Fri, 31 Mar 2017 00:50:04 +0200

=== debian/control ===
Source: limesuite
Section: hamradio
Priority: optional
Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
Uploaders: Andreas Bombe <aeb@debian.org>
Build-Depends: debhelper (>= 10),
               cmake,
               pkg-config,
               libusb-1.0-0-dev,
               libwxgtk3.0-dev,
               libsoapysdr0.6-dev,
               libi2c-dev,
               freeglut3-dev,
               libglew-dev,
               libsqlite3-dev
Standards-Version: 4.0.1
Homepage: https://myriadrf.org/projects/lime-suite/
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-hamradio/limesuite.git
Vcs-Git: https://anonscm.debian.org/git/pkg-hamradio/limesuite.git

Package: limesuite
Architecture: any
Depends: liblimesuite17.06-1 (>= ${binary:Version}),
         python, python-soapysdr,
         ${shlibs:Depends}, ${misc:Depends}
Description: tools to test, control and update LMS7 transceiver based hardware
 Lime Suite is a collection of software supporting Lime Microsystems LMS7 RF
 transceiver based hardware such as the LimeSDR, LMS7002M UNITE board, or the
 Novena with LMS7 RF board.
 .
 This package contains the command line and GUI tools to control and update the
 hardware devices.

Package: liblimesuite17.06-1
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: limesuite-udev [linux-any]
Description: library to access LMS7 transceiver based hardware
 Lime Suite is a collection of software supporting Lime Microsystems LMS7 RF
 transceiver based hardware such as the LimeSDR, LMS7002M UNITE board, or the
 Novena with LMS7 RF board.
 .
 This package contains the shared library to access LMS7 based hardware.

Package: liblimesuite-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: liblimesuite17.06-1 (= ${binary:Version}),
         ${misc:Depends}
Description: library to access LMS7 transceiver based hardware (development)
 Lime Suite is a collection of software supporting Lime Microsystems LMS7 RF
 transceiver based hardware such as the LimeSDR, LMS7002M UNITE board, or the
 Novena with LMS7 RF board.
 .
 This package contains the development files for liblimesuite.

Package: soapysdr0.6-module-lms7
Architecture: any
Multi-Arch: same
Depends: liblimesuite17.06-1 (>= ${binary:Version}),
         ${shlibs:Depends}, ${misc:Depends}
Description: Lime Microsystems LMS7 device support for SoapySDR
 Lime Suite is a collection of software supporting Lime Microsystems LMS7 RF
 transceiver based hardware such as the LimeSDR, LMS7002M UNITE board, or the
 Novena with LMS7 RF board.
 .
 This package contains a SoapySDR module to use LMS7 based hardware to transmit
 and receive.

Package: soapysdr-module-lms7
Architecture: any
Multi-Arch: same
Depends: soapysdr0.6-module-lms7, ${misc:Depends}
Description: Lime Microsystems LMS7 device support for SoapySDR (default version)
 Lime Suite is a collection of software supporting Lime Microsystems LMS7 RF
 transceiver based hardware such as the LimeSDR, LMS7002M UNITE board, or the
 Novena with LMS7 RF board.
 .
 This is an ampty dependency package that pulls in the LMS7 support module for
 the default version of libsoapysdr.

Package: limesuite-udev
Section: libs
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Lime Suite - USB rules for udev
 Lime Suite is a collection of software supporting Lime Microsystems LMS7 RF
 transceiver based hardware such as the LimeSDR, LMS7002M UNITE board, or the
 Novena with LMS7 RF board.
 .
 This package contains the udev rules to make LMS7 based hardware accessible to
 users in the plugdev group.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# for definition of DEB_VERSION
include /usr/share/dpkg/pkg-info.mk

# extract the architecture for setting the library path suffix
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_SHARED_LIBS=ON \
		-DCMAKE_AUTOSET_INSTALL_RPATH=FALSE \
		-DUDEV_RULES_PATH=/lib/udev/rules.d \
		-DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" \
		-DOVERRIDE_LIME_SUITE_VERSION="$(DEB_VERSION)"

override_dh_installdocs:
	dh_installdocs -p soapysdr-module-lms7 \
                --link-doc=soapysdr0.6-module-lms7
	dh_installdocs --remaining-packages

=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg$//, repacksuffix=+dfsg" \
https://github.com/myriadrf/LimeSuite/releases .*/v([\d\.]+)\.tar\.(?:xz|gz|bz2)

## limesuite 17.09.1+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -80,6 +80,27 @@
     #symbols are only exported from libraries/modules explicitly
     add_compile_options(-fvisibility=hidden)
     set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility-inlines-hidden")
+
+    SET(ENABLE_SIMD_FLAGS "native" CACHE STRING "Set compiler SIMD flags")
+    SET_PROPERTY(CACHE ENABLE_SIMD_FLAGS PROPERTY STRINGS none native SSE3 SSE4.2 AVX AVX2) 
+
+    if(${ENABLE_SIMD_FLAGS} MATCHES "native")
+     	add_definitions(-march=native -mfpmath=both)
+        message(STATUS "Enabling native optimizations")
+    elseif(${ENABLE_SIMD_FLAGS} MATCHES "AVX2")
+    	add_definitions(-mmmx -msse -msse2 -msse3 -mssse3 -msse4.1 -msse4.2 -mpopcnt -mavx -mfma -mavx2 -mfpmath=both)
+        message(STATUS "Enabling AVX2 instructions")
+    elseif(${ENABLE_SIMD_FLAGS} MATCHES "AVX")
+    	add_definitions(-mmmx -msse -msse2 -msse3 -mssse3 -msse4.1 -msse4.2 -mpopcnt -mavx -mfpmath=both)
+        message(STATUS "Enabling AVX instructions")
+    elseif(${ENABLE_SIMD_FLAGS} MATCHES "SSE4.2")
+    	add_definitions(-mmmx -msse -msse2 -msse3 -mssse3 -msse4.1 -msse4.2 -mpopcnt -mfpmath=both)
+	message(STATUS "Enabling SSE4.2 instructions")
+    elseif(${ENABLE_SIMD_FLAGS} MATCHES "SSE3")
+    	add_definitions(-mmmx -msse -msse2 -msse3 -mfpmath=both)
+        message(STATUS "Enabling SSE3 instructions")
+    endif()
+
 endif()
 
 if (MSVC)
@@ -87,6 +108,20 @@
     add_definitions(-D_CRT_SECURE_NO_WARNINGS)
     set( MSVC_MULTITHREAD_COMPILE_FLAGS "/MP")
     set( CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} ${MSVC_MULTITHREAD_COMPILE_FLAGS}" )
+
+    SET(ENABLE_SIMD_FLAGS "SSE2" CACHE STRING "Set compiler SIMD flags")
+    SET_PROPERTY(CACHE ENABLE_SIMD_FLAGS PROPERTY STRINGS none SSE2 AVX AVX2) 
+
+    if(${ENABLE_SIMD_FLAGS} MATCHES "AVX2")
+        add_definitions(/arch:AVX2)
+        message(STATUS "Enabling AVX2 instructions")
+    elseif(${ENABLE_SIMD_FLAGS} MATCHES "AVX")
+        add_definitions(/arch:AVX)
+        message(STATUS "Enabling AVX instructions")
+    elseif(${ENABLE_SIMD_FLAGS} MATCHES "SSE2")
+    	add_definitions(/arch:SSE2)
+        message(STATUS "Enabling SSE2 instructions")
+    endif()
 endif(MSVC)
 
 if (APPLE)
@@ -161,6 +196,32 @@
 endif()
 
 ########################################################################
+## Doxygen
+########################################################################
+find_package(Doxygen QUIET)
+include(FeatureSummary)
+include(CMakeDependentOption)
+cmake_dependent_option(ENABLE_API_DOXYGEN "Enable LMS API Doxygen documentation" ON "DOXYGEN_FOUND" OFF)
+add_feature_info(LimeSuiteDocAPI ENABLE_API_DOXYGEN "LMS API Doxygen documentation")
+if (ENABLE_API_DOXYGEN)
+  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/DoxyfileAPI.in ${CMAKE_CURRENT_BINARY_DIR}/doc/Doxyfile @ONLY)
+  add_custom_target(docAPI ALL
+    ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/doc/Doxyfile 
+    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
+    COMMENT "Generating LMS API documentation with Doxygen" VERBATIM
+    )
+endif()
+
+if(DOXYGEN_FOUND)
+  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
+  add_custom_target(doc
+    ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile 
+    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
+    COMMENT "Generating documentation with Doxygen" VERBATIM
+    )
+endif()
+
+########################################################################
 ## freedesktop environment integration
 ########################################################################
 add_subdirectory(Desktop)
@@ -198,14 +259,4 @@
     COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
 endif()
 
-find_package(Doxygen QUIET)
-
-if(DOXYGEN_FOUND)
-  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
-  add_custom_target(doc
-    ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile 
-    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
-    COMMENT "Generating API documentation with Doxygen" VERBATIM
-    )
-endif()
-
+

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -20,13 +20,12 @@
     protocols/ADCUnits.h
     protocols/LMS64CCommands.h
     protocols/LMS64CProtocol.h
-    protocols/ILimeSDRStreaming.cpp
     protocols/LMSBoards.h
     protocols/dataTypes.h
     protocols/fifo.h
     Si5351C/Si5351C.h
     FPGA_common/FPGA_common.h
-    lime/LimeSuite.h
+    API/lms7_device.h
 )
 
 include(FeatureSummary)
@@ -274,7 +273,6 @@
 # utilities
 #########################################################################
 cmake_dependent_option(ENABLE_UTILITIES "Enable utility programs" OFF "ENABLE_LIBRARY" OFF)
-add_feature_info(LimeSuiteUtilities ENABLE_UTILITIES "Additional utility programs for testing")
 if(ENABLE_UTILITIES)
     include_directories(utilityTools)
     set(utility_src_files utilityTools/pllTest.cpp)

=== debian/changelog ===
limesuite (17.09.1+dfsg-1) unstable; urgency=medium

  * New upstream release 17.09.1
  * Include sources in src/examples as examples in liblimesuite-doc

 -- Andreas Bombe <aeb@debian.org>  Wed, 27 Sep 2017 19:19:15 +0200

limesuite (17.09.0+dfsg-1) unstable; urgency=medium

  * New upstream release 17.09.0
  * Change liblimesuite ABI version from 17.06-1 to 17.09-1
  * Add newly written man pages for LimeUtil and LimeSuiteGUI
  * Install API reference and development documentation into new package
    liblimesuite-doc
  * Add Build-Depends on doxygen to build the API reference
  * Also remove GROUP="660" assignment with udev-use-tag-uaccess patch
  * Disable auto detection of SIMD features during the configure step
  * Add new patch fix-spelling-errors to fix spelling errors pointed out by
    lintian until this is integrated by upstream
  * Bump Standards-Version to 4.1.0, no changes required

 -- Andreas Bombe <aeb@debian.org>  Wed, 20 Sep 2017 03:38:30 +0200

=== debian/control ===
--- 
+++ 
@@ -6,6 +6,7 @@
 Build-Depends: debhelper (>= 10),
                cmake,
                pkg-config,
+               doxygen,
                libusb-1.0-0-dev,
                libwxgtk3.0-dev,
                libsoapysdr0.6-dev,
@@ -13,14 +14,14 @@
                freeglut3-dev,
                libglew-dev,
                libsqlite3-dev
-Standards-Version: 4.0.1
+Standards-Version: 4.1.0
 Homepage: https://myriadrf.org/projects/lime-suite/
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-hamradio/limesuite.git
 Vcs-Git: https://anonscm.debian.org/git/pkg-hamradio/limesuite.git
 
 Package: limesuite
 Architecture: any
-Depends: liblimesuite17.06-1 (>= ${binary:Version}),
+Depends: liblimesuite17.09-1 (>= ${binary:Version}),
          python, python-soapysdr,
          ${shlibs:Depends}, ${misc:Depends}
 Description: tools to test, control and update LMS7 transceiver based hardware
@@ -31,7 +32,7 @@
  This package contains the command line and GUI tools to control and update the
  hardware devices.
 
-Package: liblimesuite17.06-1
+Package: liblimesuite17.09-1
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -48,8 +49,9 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: liblimesuite17.06-1 (= ${binary:Version}),
+Depends: liblimesuite17.09-1 (= ${binary:Version}),
          ${misc:Depends}
+Suggests: liblimesuite-doc
 Description: library to access LMS7 transceiver based hardware (development)
  Lime Suite is a collection of software supporting Lime Microsystems LMS7 RF
  transceiver based hardware such as the LimeSDR, LMS7002M UNITE board, or the
@@ -57,10 +59,22 @@
  .
  This package contains the development files for liblimesuite.
 
+Package: liblimesuite-doc
+Section: doc
+Architecture: all
+Multi-Arch: foreign
+Depends: ${misc:Depends}
+Description: liblimesuite development documentation
+ Lime Suite is a collection of software supporting Lime Microsystems LMS7 RF
+ transceiver based hardware such as the LimeSDR, LMS7002M UNITE board, or the
+ Novena with LMS7 RF board.
+ .
+ This package contains the development documentation for liblimesuite.
+
 Package: soapysdr0.6-module-lms7
 Architecture: any
 Multi-Arch: same
-Depends: liblimesuite17.06-1 (>= ${binary:Version}),
+Depends: liblimesuite17.09-1 (>= ${binary:Version}),
          ${shlibs:Depends}, ${misc:Depends}
 Description: Lime Microsystems LMS7 device support for SoapySDR
  Lime Suite is a collection of software supporting Lime Microsystems LMS7 RF

## limesuite 17.12.0%2Bdfsg

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -67,6 +67,7 @@
     API/lms7_api.cpp
     API/lms7_device.cpp
     API/qLimeSDR.cpp
+    API/LimeSDR_mini.cpp
     FPGA_common/FPGA_common.cpp
     windowFunction.cpp
 )

=== src/RFSpark/CMakeLists.txt ===
add_library(RFSpark STATIC RFSpark_wxgui.cpp)
target_include_directories(RFSpark PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(RFSpark LMS7002M)

=== src/Si5351C/CMakeLists.txt ===
set(si5351_src_files
	Si5351C.cpp
	Si5351C_wxgui.cpp
)

add_library(Si5351C STATIC ${si5351_src_files})
target_include_directories(Si5351C PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(Si5351C LMS7002M)
set_property(TARGET Si5351C PROPERTY POSITION_INDEPENDENT_CODE TRUE)
